// $Header: p:\\graphics\\CVS/src/GraphicsTown/GrObject.cpp,v 1.8 2000/11/27 10:30:06 gleicher Exp $
// GraphicsTown - CS559-2000, sample solution
//
#include "GrTown_PCH.H"

#include "GrObject.H"
#include "FlyCamera.H"
#include "Behaviors.H"
#include "GrWorld.H"
#include "DrawingState.H"

int noNameCtr=1;
GrObject::GrObject(char* nb, int& nn, char* xn)
{
  ridable = 0;
  
  if (!nb) nb = "NoName";
  int cl = strlen(nb);
  if (xn)
	  cl += strlen(xn);
  name = new char[cl+12];
  if (xn)
	_snprintf(name,cl+11,"%s-%s-%d%c",nb,xn,nn++,0);
	else
	_snprintf(name,cl+11,"%s-%s-%d%c",nb,xn,nn++,0);

  idMatrix(transform);
  next = 0;
  behaviors = 0;

  children = 0;
  parent = 0;

  rideAbove = 0;
}
GrObject::~GrObject()
{
}

// null functions - not abstract since not all objects will override
// them
void GrObject::draw(DrawingState* drst)
{
  drawObList(children, drst);
}
void GrObject::drawAfter(DrawingState* drst)
{
  drawAfterObList(children, drst);
}
void GrObject::getTransform()
{
}
// we can actually ALWAYS make a camera matrix from the transform by
// inverting it
// whether or not this is useful...
bool GrObject::setTransform()
{
  Matrix camera;
  getTransform();
  copyMatrix(transform,camera);
  invertMatrix(camera);
  glMultMatrixf(&camera[0][0]);
  glTranslatef(0,-rideAbove,0);
	// printMatrix(camera); printf("\n");
  return ridable;
}
// user interface on the other hand...
bool GrObject::uiStep()
{
  return false;
}
int GrObject::handle(int)
{
	return 0;
}


//
void GrObject::simulateUntil(unsigned long t)
{
  for(Behavior* b = behaviors; b; b=b->next) {
	b->simulateUntil(t);
  }
}

GrObject* GrObject::add(GrObject* g, float x, float y, float z, float ry)
{
  g->next = children;
  children = g;
  g->parent = this;
  Matrix t1,t2;
  rotMatrix(t1,'Y',ry);
  multMatrix(t1,g->transform,t2);
  copyMatrix(t2,g->transform);
  g->transform[3][0] += x;
  g->transform[3][1] += y;
  g->transform[3][2] += z;
  return g;
}


GrObject* add(GrObject* g, float x, float y, float z, float ry)
{
  g->next = theObjects;
  theObjects = g;
  Matrix t1,t2;
  rotMatrix(t1,'Y',ry);
  multMatrix(t1,g->transform,t2);
  copyMatrix(t2,g->transform);
  g->transform[3][0] += x;
  g->transform[3][1] += y;
  g->transform[3][2] += z;
  return g;
}

void drawObList(GrObject* head, DrawingState* drst)
{
  glPushMatrix();
  for(GrObject* g = head; g; g = g->next) {
	  if (g != drst->camera) {
		  glPushMatrix();
		  glMultMatrixf(&g->transform[0][0]);
		  g->draw(drst);
		  glBindTexture(GL_TEXTURE_2D,0);
		  glPopMatrix();
	  }
  }
  glPopMatrix();
}
void drawAfterObList(GrObject* head, DrawingState* drst)
{
  glPushMatrix();
  for(GrObject* g = head; g; g = g->next) {
	  if (g != drst->camera) {
		  glPushMatrix();
		  glMultMatrixf(&g->transform[0][0]);
		  g->drawAfter(drst);
		  glBindTexture(GL_TEXTURE_2D,0);
		  glPopMatrix();
	  }
  }
  glPopMatrix();
}
